import org.ietf.ldap.LDAPConnection;
import org.ietf.ldap.LDAPException;


/**
 * ꤵ줿 LDAP Ф³ǧھ֤ǧ³Ǥ륯饹
 *
 * @version 19 May 2002
 * @author  Ryo Ichinose
 */
public class LDAPConnect
{
	/**
	 * LDAP Protocol Version 3
	 */
	public static final int LDAP_V3 = 3; // LDAPv3


	/**
	 * ꤵ줿 LDAP Ф³ǧھ֤ǧǤ롣
	 *
	 * @param host    ۥ̾⤷ IPɥ쥹
	 * @param binddn  bind 桼 DN
	 * @param bindpw  bind 桼Υѥ
	 */
	public void connect( String host, String binddn, String bindpw )
	{
		LDAPConnection lc = new LDAPConnection();

		try {
			// LDAP Ф³롣ݡȤϥǥե(389)Ȥ
			lc.connect( host, LDAPConnection.DEFAULT_PORT );
			System.out.println( "Connected to " + host );


			// ꤵ줿 DN ӥѥɤǥХ(ǧ)롣
			// ¹Ԥʤ硢anonymous ֤뤳Ȥˤʤ롣
			lc.bind( LDAPConnect.LDAP_V3, binddn, bindpw );


			// LDAP Фǧڤ줿ɤǧ롣
			//
			// lc.bind() ˴ְäѥɤꤷ硢LDAPException
			//  throw 뤬¾ͳ(ڤʤ)ˤäǧ
			// Ƥʤǽ⤢뤿ᡢisBound() ᥽åɤǳǧ롣

			if ( lc.isBound() ) {
				System.out.println( "Authenticated" );
			}
			else {
				System.out.println( "Not authenticated" );
			}

			// ³Ǥ롣
			lc.disconnect();
			System.out.println( "Disconnected" );
		}
		catch( LDAPException e ) {
			System.out.println( "LDAPException occured : " + 
					    e.toString() );
		}
	}


	/**
	 * ȥݥ
	 *
	 * @param args 
	 *    <ul>
	 *      <li>args[0] --- ۥ̾⤷ IP ɥ쥹
	 *      <li>args[1] --- bind 桼 DN
	 *      <li>args[2] --- bind 桼Υѥ
	 *    </ul>
	 */
	public static void main( String[] args )
	{
		LDAPConnect obj = new LDAPConnect();
		obj.connect( args[0], args[1], args[2] );
	}
}
